#ifndef __SF_CONNECTION_H__
#define __SF_CONNECTION_H__

#include <thread>
#include <atomic>
#include <condition_variable>
#include <vector>
#include <mutex>

#include <hardware/hardware.h>
#include <hardware/gralloc.h>
#include <system/window.h>
#include <hybris/grallocusage/GrallocUsageConversion.h>
#include <hardware/gralloc1.h>


#include "sfdroid_defs.h"

extern hw_module_t *gralloc_module;
extern gralloc1_device_t *gralloc1_device;
extern GRALLOC1_PFN_LOCK gralloc1_lock;
extern GRALLOC1_PFN_UNLOCK gralloc1_unlock;

class sfconnection_t {
    public:
        sfconnection_t() : current_status(0), fd_pass_socket(-1),  running(false),  my_have_focus(true), notified(false), nb_displays(1) 
	{
	    shb_fd = -1;
	    for (int i=0;i < 2 ;i++){
		current_buffer[i] = nullptr;
		timeout_count[i] = 0;
	}   }
        int init();
        void deinit();
        int wait_for_client();
        buffer_info_t *get_current_info(int display_id);
        ANativeWindowBuffer *get_current_buffer(int display_id);
        void wait_for_event(int timeout);
        void start_thread();
        void thread_loop();
        void stop_thread();
        void update_timeout();
        bool have_client();
        bool have_focus() { return my_have_focus; }
        void notify_buffer_done(int failed);

        void remove_buffers();

        void lost_focus();
        void gained_focus();
	int nb_displays;
	bool multiwindow;
	int  shb_fd;
    private:
        int wait_for_buffer(int &timedout, bool &is_not_a_buffer,int &display_id,bool &iswait);
        void send_status_and_cleanup();
        int current_status;
        bool thread_exited;

        int fd_pass_socket; // listen for surfaceflinger
        std::vector<int> fd_client; // the client (sharebuffer module)

        std::thread my_thread;
        std::atomic<bool> running;
        std::condition_variable buffer_cond;
        std::condition_variable back_cond;
        std::mutex notify_mutex, notify_back_mutex;

        buffer_info_t current_info[2],current_info_tmp;
        ANativeWindowBuffer* current_buffer[2];
        unsigned int timeout_count[2];

        bool my_have_focus;
        bool notified;

        std::vector<ANativeWindowBuffer*> buffers;
        std::vector<buffer_info_t> buffer_infos;
	
};

#endif

